grey = love.image.newImageData(800, 600)
grey:mapPixel(function() return 128, 128, 128, 128 end)
grey = love.graphics.newImage(grey)
fonts = {}
setmetatable(fonts, {__index = function(t, i) t[i] = love.graphics.newFont(i) return t[i] end})
game = {}


game.load = function()
	map = love.filesystem.load 'map.lua' ()
	snake1 = love.filesystem.load 'snake.lua' () ({menu.states.options.list.values[2], menu.states.options.list.values[3], menu.states.options.list.values[4]}, {up = 'up', down = 'down', left = 'left', right = 'right'})
	snake2 = love.filesystem.load 'snake.lua' () ({menu.states.options.list.values[5], menu.states.options.list.values[6], menu.states.options.list.values[7]}, {up = 'w', down = 's', left = 'a', right = 'd'})
end
game.load()

game.update = function(dt)
	dt = dt * (menu.states.options.list.values[1] / 20)
	for i, v in ipairs(snake2.squares) do
		snake1.colliding = (v[1] == snake1.x and v[2] == snake1.y) or snake1.colliding
	end
	for i, v in ipairs(snake1.squares) do
		snake2.colliding = (v[1] == snake2.x and v[2] == snake2.y) or snake2.colliding
	end
	if not snake1.colliding and not snake2.colliding then
		snake1:update(dt)
	end
	if not snake1.colliding and not snake2.colliding then
		snake2:update(dt)
	end
	if not (snake2.colliding or snake1.colliding) then
		map:update(dt)
	end
end

game.draw = function()
	love.graphics.draw(canvas, 0, 0)
	snake1:draw()
	snake2:draw()
	love.graphics.print('FPS: ' .. love.timer.getFPS(), map.width*17, 1)
	if snake1.colliding then
		love.graphics.draw(grey, 0, 0)
		love.graphics.setFont(fonts[96])
		love.graphics.printf("Game Over, 2 won", 0, 204, 800, 'center')
		love.graphics.setFont(fonts[12])
	end
	if snake2.colliding then
		love.graphics.draw(grey, 0, 0)
		love.graphics.setFont(fonts[96])
		love.graphics.printf("Game Over, 1 won", 0, 204, 800, 'center')
		love.graphics.setFont(fonts[12])
	end
end

game.keypressed = function(key, unicode)
	snake1:keypressed(key, unicode)
	snake2:keypressed(key, unicode)
	if string.char(unicode) == 'R' then
		love.load()
	end
	if string.char(unicode) == 'Q' then
		love.event.push 'quit'
	end
	if key == 'escape' then
		state = menu
	end
end