local	map = {}	

	map.width = 32
	map.height = 32
	canvas = love.graphics.newCanvas(map.width*17, map.height*17)
	map.food = {{math.random(map.width),math.random(map.height)}, {math.random(map.width),math.random(map.height)}}
	for x = 1, map.width do
		map[x] = {}
		for y = 1, map.height do
			map[x][y] = ' '
		end
	end
	for i, v in ipairs(map.food) do
		map[v[1]][v[2]] = 'o'
	end
	map.squares = {}
	map.squares[' '] = love.image.newImageData(16, 16)
	map.squares['#'] = love.image.newImageData(16, 16)
	map.squares['o'] = love.image.newImageData(16, 16)
	map.squares['_'] = love.image.newImageData(16, 16)
	map.squares[' ']:mapPixel(function(x, y) if x == 16 or y == 16 then return 0, 0, 0, 255 else return 255, 255, 255, 255 end end)
	map.squares['#']:mapPixel(function() return 0, 192, 0, 255 end)
	map.squares['o']:mapPixel(function(x, y) if ((x >= 4) and (x <= 11) and (y >= 4) and (y <= 11)) or (x == 16) or (y == 16) then return 190, 0, 0, 255 else return 255, 255, 255, 255 end end)
	map.squares['_']:mapPixel(function() return 0, 0, 192, 255 end)
	map.squares[' '] = love.graphics.newImage(map.squares[' '])
	map.squares['#'] = love.graphics.newImage(map.squares['#'])
	map.squares['o'] = love.graphics.newImage(map.squares['o'])
	map.squares['_'] = love.graphics.newImage(map.squares['_'])
	map.print = function(self)
		for i, v in ipairs(map) do
			for ii, vv in ipairs(v) do
				io.write(vv)
			end
			io.write "\n"
		end
	end
	map.draw = function(self)
		for x, v in ipairs(self) do
			for y, vv in ipairs(v) do
				love.graphics.draw(map.squares[vv], (x-1)*17+1, (y-1)*17+1)
			end
		end
	end
	map.update = function(self, dt)
		for i, v in ipairs(self.food) do
			if snake1.x == v[1] and snake1.y == v[2] then
				self[v[1]][v[2]] = ' '
				v[1], v[2] = math.random(self.width), math.random(self.height)
				self[v[1]][v[2]] = 'o'
				canvas:renderTo(function() map:draw() end)
				snake1.length = snake1.length + 1
			end
			if snake2.x == v[1] and snake2.y == v[2] then
				self[v[1]][v[2]] = ' '
				v[1], v[2] = math.random(self.width), math.random(self.height)
				self[v[1]][v[2]] = 'o'
				canvas:renderTo(function() map:draw() end)
				snake2.length = snake2.length + 1
			end
		end
	end
	canvas:renderTo(function() map:draw() end)

return map